%define	major     6.3
%define libname   %mklibname ntirpc %{major}
%define develname %mklibname ntirpc -d

Name:		libntirpc
Version:	6.3
Release:	%mkrel 1
Summary:	New Transport Independent RPC Library
Group:		System/Libraries
License:	BSD
Url:		https://github.com/nfs-ganesha/ntirpc
Source0:	https://github.com/nfs-ganesha/ntirpc/archive/v%{version}/ntirpc-%{version}.tar.gz
BuildRequires:	cmake
%ifarch x86_64 aarch64
BuildRequires:	mold
%endif
# we should switch to rdma-core
#BuildRequires:	rdmacm-devel
BuildRequires:	pkgconfig(libnsl)
BuildRequires:	pkgconfig(liburcu)
BuildRequires:	pkgconfig(krb5)

%description
This package contains a new implementation of the original libtirpc,
transport-independent RPC (TI-RPC) library for NFS-Ganesha. It has
the following features not found in libtirpc:
 1. Bi-directional operation
 2. Full-duplex operation on the TCP (vc) transport
 3. Thread-safe operating modes
 3.1 new locking primitives and lock callouts (interface change)
 3.2 stateless send/recv on the TCP transport (interface change)
 4. Flexible server integration support
 5. Event channels (remove static arrays of xprt handles, new EPOLL/KEVENT
    integration)

%package -n	%{libname}
Summary:	Transport Independent RPC Library
Group:		System/Libraries

%description -n	%{libname}
This package contains a new implementation of the original libtirpc,
transport-independent RPC (TI-RPC) library for NFS-Ganesha. It has
the following features not found in libtirpc:
 1. Bi-directional operation
 2. Full-duplex operation on the TCP (vc) transport
 3. Thread-safe operating modes
 3.1 new locking primitives and lock callouts (interface change)
 3.2 stateless send/recv on the TCP transport (interface change)
 4. Flexible server integration support
 5. Event channels (remove static arrays of xprt handles, new EPOLL/KEVENT
    integration)

%package -n	%{develname}
Summary:	Development headers for %{name}
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	ntirpc-devel%{?_isa} = %{version}-%{release}
Provides:	ntirpc-devel = %{version}-%{release}

%description -n	%{develname}
Development headers and auxiliary files for developing with %{name}.

%prep
%autosetup -p1 -n ntirpc-%{version}

%build
%cmake -DOVERRIDE_INSTALL_PREFIX=%{_prefix} \
       -DTIRPC_EPOLL=1 \
       -DUSE_GSS=ON \
       -DUSE_RPC_RDMA=OFF \
%ifarch x86_64 aarch64
       -DCMAKE_LINKER=%{_bindir}/ld.mold \
%endif
       %nil
%cmake_build

%install
%cmake_install

#install CMake files
mkdir -p %{buildroot}%{_libdir}/cmake/%{name}/
install -pm644 cmake/modules/FindNTIRPC.cmake %{buildroot}%{_libdir}/cmake/%{name}/
install -pm644 cmake/modules/LibFindMacros.cmake %{buildroot}%{_libdir}/cmake/%{name}/

%files -n %{libname}
%doc NEWS README
%license COPYING
%{_libdir}/libntirpc.so.%{major}

%files -n %{develname}
%{_libdir}/libntirpc.so
%{_includedir}/ntirpc/
%{_libdir}/pkgconfig/libntirpc.pc
%{_libdir}/cmake/%{name}/


%changelog
* Thu Dec 26 2024 wally <wally> 6.3-1.mga10
+ Revision: 2130350
- new version 6.3
- new lib major 6.3

* Thu Aug 29 2024 daviddavid <daviddavid> 6.0-1.mga10
+ Revision: 2092127
- new version: 6.0

* Tue May 21 2024 daviddavid <daviddavid> 5.8-1.mga10
+ Revision: 2065757
- new version: 5.8

* Sun Apr 14 2024 daviddavid <daviddavid> 5.0-1.mga10
+ Revision: 2057473
- new version: 5.0
- now libmajor is 5.0

* Sat Mar 19 2022 umeabot <umeabot> 1.8.0-5.mga9
+ Revision: 1800339
- Mageia 9 Mass Rebuild

* Wed Dec 01 2021 wally <wally> 1.8.0-4.mga9
+ Revision: 1760447
- rebuild for userspace-rcu 0.13.0

* Sat Dec 12 2020 wally <wally> 1.8.0-3.mga8
+ Revision: 1655817
- BR libnsl

* Sat Feb 15 2020 umeabot <umeabot> 1.8.0-2.mga8
+ Revision: 1526938
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sat Jul 06 2019 daviddavid <daviddavid> 1.8.0-1.mga8
+ Revision: 1419087
- new version: 1.8.0
- now libmajor is 1.8

* Sun Sep 23 2018 umeabot <umeabot> 1.6.2-2.mga7
+ Revision: 1299056
- Mageia 7 Mass Rebuild

* Sun Apr 08 2018 kekepower <kekepower> 1.6.2-1.mga7
+ Revision: 1216247
- Update to version 1.6.2

* Mon Mar 12 2018 kekepower <kekepower> 1.6.1-1.mga7
+ Revision: 1208763
- Update to version 1.6.1

* Wed Oct 26 2016 luigiwalser <luigiwalser> 1.4.3-1.mga6
+ Revision: 1063601
- 1.4.3

* Wed Feb 24 2016 spuhler <spuhler> 1.4.0-0.pre1.1.mga6
+ Revision: 977708
- upgrade to vers. 1.4.0pre1

* Mon Feb 15 2016 umeabot <umeabot> 1.3.1-3.mga6
+ Revision: 961153
- Mageia 6 Mass Rebuild

* Tue Oct 27 2015 wally <wally> 1.3.1-2.mga6
+ Revision: 895860
- let CMake install files to /usr/include/ntirpc directory

* Tue Oct 27 2015 wally <wally> 1.3.1-1.mga6
+ Revision: 895851
- new version 1.3.1
- drop unneeded patches
- rediff pkg-config .pc file patch
- add cmake modules to devel pkg

* Sat Oct 24 2015 wally <wally> 1.3.0-5.mga6
+ Revision: 894924
- add patch to fix pkg-config .pc file
- replace linking fix with one from upstream

* Sat Oct 24 2015 wally <wally> 1.3.0-4.mga6
+ Revision: 894906
- fix lib pkg name (make it to match with SONAME)

* Sat Oct 24 2015 wally <wally> 1.3.0-3.mga6
+ Revision: 894897
- drop unexisting requires
- build with %%cmake macro
- add patch to fix linking

* Thu Oct 22 2015 spuhler <spuhler> 1.3.0-2.mga6
+ Revision: 894066
- correctly name the libs

* Wed Oct 21 2015 spuhler <spuhler> 1.3.0-1.mga6
+ Revision: 893946
- first build
- imported package libntirpc


* Fri Oct 9 2015 Kaleb S. KEITHLEY <kkeithle at redhat.com> 1.3.0-3
- libntirpc 1.3.0 GA, w/ -DTIRPC_EPOLL=ON

* Wed Sep 9 2015 Kaleb S. KEITHLEY <kkeithle at redhat.com> 1.3.0-2
- libntirpc 1.3.0 GA, w/ correct top-level CMakeList.txt

* Wed Sep 9 2015 Kaleb S. KEITHLEY <kkeithle at redhat.com> 1.3.0-1
- libntirpc 1.3.0 GA

* Thu Jul 16 2015 Kaleb S. KEITHLEY <kkeithle at redhat.com> 1.2.1-3
- RHEL 6 finally has new enough cmake
- use -isystem ... to ensure correct <rpc/rpc*.h> are used
- ensure -DTIRPC_EPOLL is defined for correct evchan functionality

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Mar 23 2015 Kaleb S. KEITHLEY <kkeithle at redhat.com> 1.2.1-1
- Initial commit
